// config: norepeat
#include "GetObjects.js"
#include "WaitForDialogDone.js"

function factory( factoryname ) { var f = moi.command.createFactory( factoryname ); for ( var i = 1; i < arguments.length; i++ ) if (arguments[i] !==null) f.setInput( i - 1, arguments[i] ); var obj = f.calculate();f.cancel(); return obj; }
var line = '', tmp_line = '',vertex = [], j,lcount = 0,tcount = 0,nr=0;alertcount=0;filename="";
lofts=moi.geometryDatabase.createObjectList();
edges=moi.geometryDatabase.createObjectList();
var sl=0;

function start(){
while ( true )
	{
		moi.ui.commandDialog.waitForEvent();
		var e  = moi.ui.commandDialog.event;
		if ( e == 'cancel' ) {break; }
		if ( e == 'import' ) {moi.ui.alert("This can take a time...\n\nDON'T KILL MOI UNTIL YOU SEE SMOKE ;-)");var startTime = new Date();var triangles=importSTL();if(triangles.length<1){break;};var solid=JoinTriangles(triangles);var sol=solid.numSolids;if(sol<1){var message="SORRY!\nI WAS NOT ABLE TO MAKE A SOLID!\nDont't try to \"Clean flat surfaces\"";}else{var message=sol+" SOLID CREATED!";};var period = (new Date() - startTime);moi.view.resetAll();moi.ui.alert(message+"\n processing time: "+period/1000+" sec");clean(solid);break; }
		if ( e == 'clean' ) {onlyClean();break; }
	}
}
function onlyClean()
{
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'ObjectPrompt' );
	moi.ui.showUI( 'ChooseSolid' );
	moi.ui.hideUI( 'Yes' );
	moi.ui.showUI( 'Done' );
	moi.ui.endUIUpdate();
var objectpicker = moi.ui.createObjectPicker();
objectpicker.allowTopLevelObjects();
	while ( true )
	{
		if ( !objectpicker.waitForEvent() ) return;
		if (objectpicker.done()) break;
	}

solid = objectpicker.objects;
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'ObjectPrompt' );
	moi.ui.hideUI( 'ChooseSolid' );
	moi.ui.hideUI( 'Yes' );
	moi.ui.hideUI( 'Done' );
	moi.ui.endUIUpdate();
clean(solid);

}

function importSTL()
{
triangles=moi.geometryDatabase.createObjectList();
        if (filename === "")
            filename = moi.filesystem.getOpenFileName('Choose a STL file', 'STL files (*.stl, *.stl)|*.stl;*.stl|All files (*.*)|*.*');
           // wait();
            var file = moi.filesystem.openFileStream(filename, 'r');
            var startTime = new Date();
            while (!file.AtEOF) {
                tmp_line = file.readLine().trim();lcount++;
                if (tmp_line[0] === 'v') {
                    vertex=[];
                    line = tmp_line.split(' ');
                    for (var j = 1; j < 4; j++) {
                        vertex[j] = moi.vectorMath.createPoint(line[1],line[2],line[3]);
                        line = file.readLine().trim().split(' ');lcount++;
                    }
                  var e0 =  factory('line',vertex[1],vertex[2]);
                  var e1 =  factory('line',vertex[2],vertex[3]);
                  var e2 =  factory('line',vertex[3],vertex[1]);
                  var edges=moi.geometryDatabase.createObjectList();
                  edges.addObject(e0.item(0));
                  edges.addObject(e1.item(0));
                  edges.addObject(e2.item(0));
                   psrf = moi.command.createFactory( 'planarsrf' );
				psrf.setInput( 0, edges);
				 var tri=psrf.calculate();
                  //var tri=factory('planarsrf',edges);
                 
                  if(tri.length>0){/*psrf.commit();*/triangles.addObject(tri.item(0));tcount++;}else{alertcount++;}
                }
    }
            file.close();
            var period = (new Date() - startTime);
            moi.geometryDatabase.addObjects(triangles);
            moi.geometryDatabase.selectAll();
            moi.geometryDatabase.getSelectedObjects().setProperty('name','STLtriangles');
        
          moi.view.resetAll();
            var message=triangles.length + " Triangles imported \n"+ alertcount + " Import problems";
        if(alertcount>0){message+=" ignored";}
        message+="\n processing time: "+period/1000+" sec \n I will try to make a solid";
        if(triangles.length<1){message="No triangles imported! \n Did you try to import a binary STL?\n This script only handels ascii STLs!";}
        moi.ui.alert(message);
        duplicate();
            return triangles;
}

function JoinTriangles(triangles)
{
        fact = moi.command.createFactory( 'join' );
		fact.setInput( 0, triangles);
		var solid=fact.calculate();
		moi.geometryDatabase.addObjects(solid);
		//fact.commit();
		solid.setProperty('name','STLsolid');
		solid.setProperty('selected',1);
		return solid;
}


function clean(solid)
{
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'ObjectPrompt' );
	moi.ui.hideUI( 'JoinPrompt' );
	moi.ui.showUI( 'CleanPrompt' );
	//moi.ui.showUI( 'YesNo' );
	//moi.ui.showUI( 'No' );
	moi.ui.endUIUpdate();

while ( true )
	{
		moi.ui.commandDialog.waitForEvent();
		var e  = moi.ui.commandDialog.event;
		if ( e == 'cancel' ) {break; }
		if ( e == 'done' ) {moi.geometryDatabase.hide();var startTime = new Date();var STLclean=cleanFlat(solid);var period = (new Date() - startTime);moi.ui.alert("processing time: "+period/1000+" sec");break; }
		if ( e == 'no' ) {break; }
		
	}
	

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'CleanPrompt' );
	moi.ui.hideUI( 'JoinPrompt' );
	moi.ui.showUI( 'CleanCurvePrompt' );
	moi.ui.hideUI( 'No' );

	moi.ui.endUIUpdate();
while ( true )
	{
		moi.ui.commandDialog.waitForEvent();
		var e  = moi.ui.commandDialog.event;
		if ( e == 'cancel' ) {break; }
		if ( e == 'done' ) {polys();break; }
		if ( e == 'no' ) {break;}
		
	}

}
function duplicate()
{
var a =moi.geometryDatabase.getSelectedObjects();
var sput=moi.VectorMath.createPoint(0, 0, 0);

	var cop = moi.command.createFactory( 'copy' );
	cop.setInput( 0, a);
	cop.setInput( 1, sput);
	cop.setInput( 2, sput);
	cop.setInput( 3, true);
	var copyobj=cop.calculate();
	cop.commit();
	moi.geometryDatabase.selectAll();
moi.geometryDatabase.hide();

}

function polys()
{
moi.ui.alert("This function will help you to redraw the STL polylines to nice curves, cycles or lines. \n After choosing all polylines which should be curves or cycles the function will redraw the lines and will \n DELETE ALL CORRESPONDING FACES and LEAVES YOU ALONE with rebuilding the object. \n Dont miss to look into the objects folder, there will be the original STL and the flat cleaned object \n to help you rebuilding.");

var a =moi.geometryDatabase.getSelectedObjects();
var sput=moi.VectorMath.createPoint(0, 0, 0);

	var cop = moi.command.createFactory( 'copy' );
	cop.setInput( 0, a);
	cop.setInput( 1, sput);
	cop.setInput( 2, sput);
	cop.setInput( 3, true);
	var copyobj=cop.calculate();
	cop.commit();
moi.geometryDatabase.getSelectedObjects().setProperty('name','STLcleanFlat');
moi.geometryDatabase.getSelectedObjects().setProperty('hidden',1);
moi.geometryDatabase.selectAll();
moi.geometryDatabase.getSelectedObjects().setProperty('name','STLcleanPolys');
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'CleanCurvePrompt' );
	moi.ui.showUI( 'PolylinePrompt' );

	moi.ui.endUIUpdate();


cleanCurve();	

}
function cleanFlat(solid)
{

var STLclean=cleanSurfaces(solid.getBoundingBox(),solid);

moi.geometryDatabase.selectAll();
moi.geometryDatabase.getSelectedObjects().setProperty('name','STLcleanFlat');
return STLclean;
}

function delConFaces(edges)
{

faces=moi.geometryDatabase.createObjectList();
alledges=moi.geometryDatabase.createObjectList();
for ( var i = 0; i < edges.length; ++i ){
	var face=edges.item(i).getFacesOfEdge();
	for ( var j = 0; j < face.length; ++j ){
		faces.addObject(face.item(j));
	}
}
faces.setProperty('selected',true);

del= moi.command.createFactory( 'delete' );
	del.setInput( 0, faces);
	del.update();
	del.commit();
edges=moi.geometryDatabase.createObjectList();
//moi.ui.alert("Delete?");
moi.geometryDatabase.selectAll();
moi.geometryDatabase.getSelectedObjects().setProperty('name','STLcleanPolys');
//return STLclean;
}


function cleanSurfaces(bbox,body)
{
var bboxx=moi.VectorMath.createPoint(bbox.min.x+bbox.xLength,bbox.min.y,bbox.min.z);
var bboxy=moi.VectorMath.createPoint(bbox.min.x,bbox.min.y+bbox.yLength,bbox.min.z);
var factory = moi.command.createFactory( 'box3pts' );
	factory.setInput( 0, bbox.min );
	factory.setInput( 1, bboxx );
	factory.setInput( 2, bboxy );
	factory.setInput( 5, bbox.zLength );
	var box=factory.calculate();
	factory.reset();
var factory = moi.command.createFactory( 'offset' );
	factory.setInput( 0, box );
	factory.setInput( 1, 2);
	var boxB=factory.calculate();

	factory.reset();
var factory = moi.command.createFactory( 'offset' );
	factory.setInput( 0, box );
	factory.setInput( 1, 1);
	var boxS=factory.calculate();

	factory.reset();
var factory = moi.command.createFactory( 'booleandifference' );
	factory.setInput( 0, boxB );
	factory.setInput( 1, body );
	factory.setInput( 2, true);
	var boxBD1=factory.calculate();
	factory.reset();

var factory = moi.command.createFactory( 'booleandifference' );
	factory.setInput( 0, boxS );
	factory.setInput( 1, boxBD1 );
	factory.setInput( 2, false);
	var STLclean=factory.calculate();
	factory.commit();

	factory.reset();

	return STLclean;
}
function PolylineToCurve(objects)
{	
	var factory = moi.command.createFactory( 'separate' );
	factory.setInput( 0, objects );
	var Curves=factory.calculate();

		
	var polysegments = Curves; // From MarkCurveStart	
	polysegments.sortBySelectionOrder();
	if ( polysegments.length < 2 )
		return;
	
	var len = polysegments.length;
	var lenMinus = (len - 1 );
	var lastSegment = polysegments.item(lenMinus);
	var lastPt =  lastSegment.getEndPt();
	
	var curveV, curveF = moi.command.createFactory( 'interpcurve' );
	for ( var iCrv = 0; iCrv < len; ++iCrv )	
	{
		var segment = polysegments.item(iCrv);
		var nextPt = segment.getStartPt();
		curveF.createInput( 'point' );		
		curveF.setInput( curveF.numInputs - 1, nextPt );
	}
	curveF.createInput( 'point' );		
	curveF.setInput( curveF.numInputs - 1, lastPt );
		
	curveF.update();
	

var NewCurve=curveF.calculate();
	curveF.commit();
	lofts.addObject(NewCurve.item(0));
	return NewCurve;
}
function PolylineToCircle(objects)
{	
	var factory = moi.command.createFactory( 'separate' );
	factory.setInput( 0, objects );
	var Curves=factory.calculate();
		
	var polysegments = Curves; // From MarkCurveStart	
	polysegments.sortBySelectionOrder();
	if ( polysegments.length < 2 )
		return;
	
	var len = polysegments.length;
	var len3=Math.round(len/3);
	var firstSegment = polysegments.item(0);
	var firstPt =  firstSegment.getEndPt();
	var middleSegment = polysegments.item(len3);
	var middlePt =  middleSegment.getEndPt();
	var lastSegment = polysegments.item(len3*2);
	var lastPt =  lastSegment.getEndPt();
	
	factory.reset();
	
	var factory = moi.command.createFactory( 'circle3pt' );
	factory.setInput( 0, firstPt );
	factory.setInput( 1, middlePt );
	factory.setInput( 2, lastPt );
var NewCurve=factory.calculate();
	factory.commit();
	lofts.addObject(NewCurve.item(0));
	return NewCurve;
}
function PolylineToLine(objects)
{
	
	var factory = moi.command.createFactory( 'line' );
	factory.setInput( 0, objects.item(0).getStartPt() );
	factory.setInput( 1, objects.item(0).getEndPt() );
	var NewCurve=factory.calculate();
	factory.commit();
		
	
	lofts.addObject(NewCurve.item(0));
	return NewCurve;
}
function cleanCurve()
{
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'CleanCurvePrompt' );
	moi.ui.hideUI( 'PolylinePrompt' );
	moi.ui.hideUI( 'PolylineNewPrompt' );
	moi.ui.showUI( 'Polyline2Prompt' );
	moi.ui.showUI( 'Done' );
	moi.ui.hideUI( 'Yes' );
	moi.ui.hideUI( 'Finish' );
	moi.ui.endUIUpdate();
var objectpicker = moi.ui.createObjectPicker();
	while ( true )
	{
		if ( !objectpicker.waitForEvent() ) return;
		if (objectpicker.done()) break;
	}

objects = objectpicker.objects;

	var factory = moi.command.createFactory( 'join' );
	factory.setInput( 0, objects );
	var join=factory.calculate();

	moi.geometryDatabase.addObjects(join);

for ( var i = 0; i < objects.length; ++i ){objects.item(i).styleIndex=1;edges.addObject(objects.item(i));}

for ( var k = 0; k < join.length; ++k )
{
moi.geometryDatabase.deselectAll(); 
join.item(k).selected=true;
moi.view.resetAll();
moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'CleanCurvePrompt' );
	moi.ui.hideUI( 'PolylinePrompt' );
	moi.ui.hideUI( 'PolylineNewPrompt' );
	moi.ui.hideUI( 'Polyline2Prompt' );
	moi.ui.hideUI( 'Done' );
	moi.ui.hideUI( 'Yes' );
	moi.ui.hideUI( 'Finish' );
	moi.ui.showUI( 'Choose' );
moi.ui.endUIUpdate();
while ( true )
	{
		moi.ui.commandDialog.waitForEvent();
		var e  = moi.ui.commandDialog.event;
		if ( e == 'cancel' ) {break; }
		if ( e == 'circle' ) {var NewCurveIn=PolylineToCircle(moi.geometryDatabase.getSelectedObjects());break; }
		if ( e == 'curve' ) {var NewCurveIn=PolylineToCurve(moi.geometryDatabase.getSelectedObjects());break; }
		if ( e == 'line' ) {var NewCurveIn=PolylineToLine(moi.geometryDatabase.getSelectedObjects());break; }
	}


}
delConFaces(edges);
var dele= moi.command.createFactory( 'delete' );
	dele.setInput( 0, join);
	dele.update();
	dele.commit();
moi.view.resetAll();

}



function wait()
{
var commandDialog = moi.ui.commandDialog;
while ( 1 )
	{

		if ( !commandDialog.waitForEvent() )
			return;

		if ( commandDialog.event == 'done' )
			break;
			
		if ( commandDialog.event == 'finish' )
			break;
			
	}
}


start();

